'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _interopDefault (ex) { return (ex && (typeof ex === 'object') && 'default' in ex) ? ex['default'] : ex; }

var get = _interopDefault(require('lodash.get'));
var set = _interopDefault(require('lodash.set'));
var React = require('react');
var React__default = _interopDefault(React);
var isEqual = _interopDefault(require('react-fast-compare'));
var createContext = _interopDefault(require('create-react-context'));
var unset = _interopDefault(require('lodash.unset'));
var debounce = _interopDefault(require('lodash.debounce'));

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

var runtime = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

!(function(global) {

  var Op = Object.prototype;
  var hasOwn = Op.hasOwnProperty;
  var undefined; // More compressible than void 0.
  var $Symbol = typeof Symbol === "function" ? Symbol : {};
  var iteratorSymbol = $Symbol.iterator || "@@iterator";
  var asyncIteratorSymbol = $Symbol.asyncIterator || "@@asyncIterator";
  var toStringTagSymbol = $Symbol.toStringTag || "@@toStringTag";
  var runtime = global.regeneratorRuntime;
  if (runtime) {
    {
      // If regeneratorRuntime is defined globally and we're in a module,
      // make the exports object identical to regeneratorRuntime.
      module.exports = runtime;
    }
    // Don't bother evaluating the rest of this file if the runtime was
    // already defined globally.
    return;
  }

  // Define the runtime globally (as expected by generated code) as either
  // module.exports (if we're in a module) or a new, empty object.
  runtime = global.regeneratorRuntime = module.exports;

  function wrap(innerFn, outerFn, self, tryLocsList) {
    // If outerFn provided and outerFn.prototype is a Generator, then outerFn.prototype instanceof Generator.
    var protoGenerator = outerFn && outerFn.prototype instanceof Generator ? outerFn : Generator;
    var generator = Object.create(protoGenerator.prototype);
    var context = new Context(tryLocsList || []);

    // The ._invoke method unifies the implementations of the .next,
    // .throw, and .return methods.
    generator._invoke = makeInvokeMethod(innerFn, self, context);

    return generator;
  }
  runtime.wrap = wrap;

  // Try/catch helper to minimize deoptimizations. Returns a completion
  // record like context.tryEntries[i].completion. This interface could
  // have been (and was previously) designed to take a closure to be
  // invoked without arguments, but in all the cases we care about we
  // already have an existing method we want to call, so there's no need
  // to create a new function object. We can even get away with assuming
  // the method takes exactly one argument, since that happens to be true
  // in every case, so we don't have to touch the arguments object. The
  // only additional allocation required is the completion record, which
  // has a stable shape and so hopefully should be cheap to allocate.
  function tryCatch(fn, obj, arg) {
    try {
      return { type: "normal", arg: fn.call(obj, arg) };
    } catch (err) {
      return { type: "throw", arg: err };
    }
  }

  var GenStateSuspendedStart = "suspendedStart";
  var GenStateSuspendedYield = "suspendedYield";
  var GenStateExecuting = "executing";
  var GenStateCompleted = "completed";

  // Returning this object from the innerFn has the same effect as
  // breaking out of the dispatch switch statement.
  var ContinueSentinel = {};

  // Dummy constructor functions that we use as the .constructor and
  // .constructor.prototype properties for functions that return Generator
  // objects. For full spec compliance, you may wish to configure your
  // minifier not to mangle the names of these two functions.
  function Generator() {}
  function GeneratorFunction() {}
  function GeneratorFunctionPrototype() {}

  // This is a polyfill for %IteratorPrototype% for environments that
  // don't natively support it.
  var IteratorPrototype = {};
  IteratorPrototype[iteratorSymbol] = function () {
    return this;
  };

  var getProto = Object.getPrototypeOf;
  var NativeIteratorPrototype = getProto && getProto(getProto(values([])));
  if (NativeIteratorPrototype &&
      NativeIteratorPrototype !== Op &&
      hasOwn.call(NativeIteratorPrototype, iteratorSymbol)) {
    // This environment has a native %IteratorPrototype%; use it instead
    // of the polyfill.
    IteratorPrototype = NativeIteratorPrototype;
  }

  var Gp = GeneratorFunctionPrototype.prototype =
    Generator.prototype = Object.create(IteratorPrototype);
  GeneratorFunction.prototype = Gp.constructor = GeneratorFunctionPrototype;
  GeneratorFunctionPrototype.constructor = GeneratorFunction;
  GeneratorFunctionPrototype[toStringTagSymbol] =
    GeneratorFunction.displayName = "GeneratorFunction";

  // Helper for defining the .next, .throw, and .return methods of the
  // Iterator interface in terms of a single ._invoke method.
  function defineIteratorMethods(prototype) {
    ["next", "throw", "return"].forEach(function(method) {
      prototype[method] = function(arg) {
        return this._invoke(method, arg);
      };
    });
  }

  runtime.isGeneratorFunction = function(genFun) {
    var ctor = typeof genFun === "function" && genFun.constructor;
    return ctor
      ? ctor === GeneratorFunction ||
        // For the native GeneratorFunction constructor, the best we can
        // do is to check its .name property.
        (ctor.displayName || ctor.name) === "GeneratorFunction"
      : false;
  };

  runtime.mark = function(genFun) {
    if (Object.setPrototypeOf) {
      Object.setPrototypeOf(genFun, GeneratorFunctionPrototype);
    } else {
      genFun.__proto__ = GeneratorFunctionPrototype;
      if (!(toStringTagSymbol in genFun)) {
        genFun[toStringTagSymbol] = "GeneratorFunction";
      }
    }
    genFun.prototype = Object.create(Gp);
    return genFun;
  };

  // Within the body of any async function, `await x` is transformed to
  // `yield regeneratorRuntime.awrap(x)`, so that the runtime can test
  // `hasOwn.call(value, "__await")` to determine if the yielded value is
  // meant to be awaited.
  runtime.awrap = function(arg) {
    return { __await: arg };
  };

  function AsyncIterator(generator) {
    function invoke(method, arg, resolve, reject) {
      var record = tryCatch(generator[method], generator, arg);
      if (record.type === "throw") {
        reject(record.arg);
      } else {
        var result = record.arg;
        var value = result.value;
        if (value &&
            typeof value === "object" &&
            hasOwn.call(value, "__await")) {
          return Promise.resolve(value.__await).then(function(value) {
            invoke("next", value, resolve, reject);
          }, function(err) {
            invoke("throw", err, resolve, reject);
          });
        }

        return Promise.resolve(value).then(function(unwrapped) {
          // When a yielded Promise is resolved, its final value becomes
          // the .value of the Promise<{value,done}> result for the
          // current iteration. If the Promise is rejected, however, the
          // result for this iteration will be rejected with the same
          // reason. Note that rejections of yielded Promises are not
          // thrown back into the generator function, as is the case
          // when an awaited Promise is rejected. This difference in
          // behavior between yield and await is important, because it
          // allows the consumer to decide what to do with the yielded
          // rejection (swallow it and continue, manually .throw it back
          // into the generator, abandon iteration, whatever). With
          // await, by contrast, there is no opportunity to examine the
          // rejection reason outside the generator function, so the
          // only option is to throw it from the await expression, and
          // let the generator function handle the exception.
          result.value = unwrapped;
          resolve(result);
        }, reject);
      }
    }

    var previousPromise;

    function enqueue(method, arg) {
      function callInvokeWithMethodAndArg() {
        return new Promise(function(resolve, reject) {
          invoke(method, arg, resolve, reject);
        });
      }

      return previousPromise =
        // If enqueue has been called before, then we want to wait until
        // all previous Promises have been resolved before calling invoke,
        // so that results are always delivered in the correct order. If
        // enqueue has not been called before, then it is important to
        // call invoke immediately, without waiting on a callback to fire,
        // so that the async generator function has the opportunity to do
        // any necessary setup in a predictable way. This predictability
        // is why the Promise constructor synchronously invokes its
        // executor callback, and why async functions synchronously
        // execute code before the first await. Since we implement simple
        // async functions in terms of async generators, it is especially
        // important to get this right, even though it requires care.
        previousPromise ? previousPromise.then(
          callInvokeWithMethodAndArg,
          // Avoid propagating failures to Promises returned by later
          // invocations of the iterator.
          callInvokeWithMethodAndArg
        ) : callInvokeWithMethodAndArg();
    }

    // Define the unified helper method that is used to implement .next,
    // .throw, and .return (see defineIteratorMethods).
    this._invoke = enqueue;
  }

  defineIteratorMethods(AsyncIterator.prototype);
  AsyncIterator.prototype[asyncIteratorSymbol] = function () {
    return this;
  };
  runtime.AsyncIterator = AsyncIterator;

  // Note that simple async functions are implemented on top of
  // AsyncIterator objects; they just return a Promise for the value of
  // the final result produced by the iterator.
  runtime.async = function(innerFn, outerFn, self, tryLocsList) {
    var iter = new AsyncIterator(
      wrap(innerFn, outerFn, self, tryLocsList)
    );

    return runtime.isGeneratorFunction(outerFn)
      ? iter // If outerFn is a generator, return the full iterator.
      : iter.next().then(function(result) {
          return result.done ? result.value : iter.next();
        });
  };

  function makeInvokeMethod(innerFn, self, context) {
    var state = GenStateSuspendedStart;

    return function invoke(method, arg) {
      if (state === GenStateExecuting) {
        throw new Error("Generator is already running");
      }

      if (state === GenStateCompleted) {
        if (method === "throw") {
          throw arg;
        }

        // Be forgiving, per 25.3.3.3.3 of the spec:
        // https://people.mozilla.org/~jorendorff/es6-draft.html#sec-generatorresume
        return doneResult();
      }

      context.method = method;
      context.arg = arg;

      while (true) {
        var delegate = context.delegate;
        if (delegate) {
          var delegateResult = maybeInvokeDelegate(delegate, context);
          if (delegateResult) {
            if (delegateResult === ContinueSentinel) continue;
            return delegateResult;
          }
        }

        if (context.method === "next") {
          // Setting context._sent for legacy support of Babel's
          // function.sent implementation.
          context.sent = context._sent = context.arg;

        } else if (context.method === "throw") {
          if (state === GenStateSuspendedStart) {
            state = GenStateCompleted;
            throw context.arg;
          }

          context.dispatchException(context.arg);

        } else if (context.method === "return") {
          context.abrupt("return", context.arg);
        }

        state = GenStateExecuting;

        var record = tryCatch(innerFn, self, context);
        if (record.type === "normal") {
          // If an exception is thrown from innerFn, we leave state ===
          // GenStateExecuting and loop back for another invocation.
          state = context.done
            ? GenStateCompleted
            : GenStateSuspendedYield;

          if (record.arg === ContinueSentinel) {
            continue;
          }

          return {
            value: record.arg,
            done: context.done
          };

        } else if (record.type === "throw") {
          state = GenStateCompleted;
          // Dispatch the exception by looping back around to the
          // context.dispatchException(context.arg) call above.
          context.method = "throw";
          context.arg = record.arg;
        }
      }
    };
  }

  // Call delegate.iterator[context.method](context.arg) and handle the
  // result, either by returning a { value, done } result from the
  // delegate iterator, or by modifying context.method and context.arg,
  // setting context.delegate to null, and returning the ContinueSentinel.
  function maybeInvokeDelegate(delegate, context) {
    var method = delegate.iterator[context.method];
    if (method === undefined) {
      // A .throw or .return when the delegate iterator has no .throw
      // method always terminates the yield* loop.
      context.delegate = null;

      if (context.method === "throw") {
        if (delegate.iterator.return) {
          // If the delegate iterator has a return method, give it a
          // chance to clean up.
          context.method = "return";
          context.arg = undefined;
          maybeInvokeDelegate(delegate, context);

          if (context.method === "throw") {
            // If maybeInvokeDelegate(context) changed context.method from
            // "return" to "throw", let that override the TypeError below.
            return ContinueSentinel;
          }
        }

        context.method = "throw";
        context.arg = new TypeError(
          "The iterator does not provide a 'throw' method");
      }

      return ContinueSentinel;
    }

    var record = tryCatch(method, delegate.iterator, context.arg);

    if (record.type === "throw") {
      context.method = "throw";
      context.arg = record.arg;
      context.delegate = null;
      return ContinueSentinel;
    }

    var info = record.arg;

    if (! info) {
      context.method = "throw";
      context.arg = new TypeError("iterator result is not an object");
      context.delegate = null;
      return ContinueSentinel;
    }

    if (info.done) {
      // Assign the result of the finished delegate to the temporary
      // variable specified by delegate.resultName (see delegateYield).
      context[delegate.resultName] = info.value;

      // Resume execution at the desired location (see delegateYield).
      context.next = delegate.nextLoc;

      // If context.method was "throw" but the delegate handled the
      // exception, let the outer generator proceed normally. If
      // context.method was "next", forget context.arg since it has been
      // "consumed" by the delegate iterator. If context.method was
      // "return", allow the original .return call to continue in the
      // outer generator.
      if (context.method !== "return") {
        context.method = "next";
        context.arg = undefined;
      }

    } else {
      // Re-yield the result returned by the delegate method.
      return info;
    }

    // The delegate iterator is finished, so forget it and continue with
    // the outer generator.
    context.delegate = null;
    return ContinueSentinel;
  }

  // Define Generator.prototype.{next,throw,return} in terms of the
  // unified ._invoke helper method.
  defineIteratorMethods(Gp);

  Gp[toStringTagSymbol] = "Generator";

  // A Generator should always return itself as the iterator object when the
  // @@iterator function is called on it. Some browsers' implementations of the
  // iterator prototype chain incorrectly implement this, causing the Generator
  // object to not be returned from this call. This ensures that doesn't happen.
  // See https://github.com/facebook/regenerator/issues/274 for more details.
  Gp[iteratorSymbol] = function() {
    return this;
  };

  Gp.toString = function() {
    return "[object Generator]";
  };

  function pushTryEntry(locs) {
    var entry = { tryLoc: locs[0] };

    if (1 in locs) {
      entry.catchLoc = locs[1];
    }

    if (2 in locs) {
      entry.finallyLoc = locs[2];
      entry.afterLoc = locs[3];
    }

    this.tryEntries.push(entry);
  }

  function resetTryEntry(entry) {
    var record = entry.completion || {};
    record.type = "normal";
    delete record.arg;
    entry.completion = record;
  }

  function Context(tryLocsList) {
    // The root entry object (effectively a try statement without a catch
    // or a finally block) gives us a place to store values thrown from
    // locations where there is no enclosing try statement.
    this.tryEntries = [{ tryLoc: "root" }];
    tryLocsList.forEach(pushTryEntry, this);
    this.reset(true);
  }

  runtime.keys = function(object) {
    var keys = [];
    for (var key in object) {
      keys.push(key);
    }
    keys.reverse();

    // Rather than returning an object with a next method, we keep
    // things simple and return the next function itself.
    return function next() {
      while (keys.length) {
        var key = keys.pop();
        if (key in object) {
          next.value = key;
          next.done = false;
          return next;
        }
      }

      // To avoid creating an additional object, we just hang the .value
      // and .done properties off the next function object itself. This
      // also ensures that the minifier will not anonymize the function.
      next.done = true;
      return next;
    };
  };

  function values(iterable) {
    if (iterable) {
      var iteratorMethod = iterable[iteratorSymbol];
      if (iteratorMethod) {
        return iteratorMethod.call(iterable);
      }

      if (typeof iterable.next === "function") {
        return iterable;
      }

      if (!isNaN(iterable.length)) {
        var i = -1, next = function next() {
          while (++i < iterable.length) {
            if (hasOwn.call(iterable, i)) {
              next.value = iterable[i];
              next.done = false;
              return next;
            }
          }

          next.value = undefined;
          next.done = true;

          return next;
        };

        return next.next = next;
      }
    }

    // Return an iterator with no values.
    return { next: doneResult };
  }
  runtime.values = values;

  function doneResult() {
    return { value: undefined, done: true };
  }

  Context.prototype = {
    constructor: Context,

    reset: function(skipTempReset) {
      this.prev = 0;
      this.next = 0;
      // Resetting context._sent for legacy support of Babel's
      // function.sent implementation.
      this.sent = this._sent = undefined;
      this.done = false;
      this.delegate = null;

      this.method = "next";
      this.arg = undefined;

      this.tryEntries.forEach(resetTryEntry);

      if (!skipTempReset) {
        for (var name in this) {
          // Not sure about the optimal order of these conditions:
          if (name.charAt(0) === "t" &&
              hasOwn.call(this, name) &&
              !isNaN(+name.slice(1))) {
            this[name] = undefined;
          }
        }
      }
    },

    stop: function() {
      this.done = true;

      var rootEntry = this.tryEntries[0];
      var rootRecord = rootEntry.completion;
      if (rootRecord.type === "throw") {
        throw rootRecord.arg;
      }

      return this.rval;
    },

    dispatchException: function(exception) {
      if (this.done) {
        throw exception;
      }

      var context = this;
      function handle(loc, caught) {
        record.type = "throw";
        record.arg = exception;
        context.next = loc;

        if (caught) {
          // If the dispatched exception was caught by a catch block,
          // then let that catch block handle the exception normally.
          context.method = "next";
          context.arg = undefined;
        }

        return !! caught;
      }

      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        var record = entry.completion;

        if (entry.tryLoc === "root") {
          // Exception thrown outside of any try block that could handle
          // it, so set the completion value of the entire function to
          // throw the exception.
          return handle("end");
        }

        if (entry.tryLoc <= this.prev) {
          var hasCatch = hasOwn.call(entry, "catchLoc");
          var hasFinally = hasOwn.call(entry, "finallyLoc");

          if (hasCatch && hasFinally) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            } else if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else if (hasCatch) {
            if (this.prev < entry.catchLoc) {
              return handle(entry.catchLoc, true);
            }

          } else if (hasFinally) {
            if (this.prev < entry.finallyLoc) {
              return handle(entry.finallyLoc);
            }

          } else {
            throw new Error("try statement without catch or finally");
          }
        }
      }
    },

    abrupt: function(type, arg) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc <= this.prev &&
            hasOwn.call(entry, "finallyLoc") &&
            this.prev < entry.finallyLoc) {
          var finallyEntry = entry;
          break;
        }
      }

      if (finallyEntry &&
          (type === "break" ||
           type === "continue") &&
          finallyEntry.tryLoc <= arg &&
          arg <= finallyEntry.finallyLoc) {
        // Ignore the finally entry if control is not jumping to a
        // location outside the try/catch block.
        finallyEntry = null;
      }

      var record = finallyEntry ? finallyEntry.completion : {};
      record.type = type;
      record.arg = arg;

      if (finallyEntry) {
        this.method = "next";
        this.next = finallyEntry.finallyLoc;
        return ContinueSentinel;
      }

      return this.complete(record);
    },

    complete: function(record, afterLoc) {
      if (record.type === "throw") {
        throw record.arg;
      }

      if (record.type === "break" ||
          record.type === "continue") {
        this.next = record.arg;
      } else if (record.type === "return") {
        this.rval = this.arg = record.arg;
        this.method = "return";
        this.next = "end";
      } else if (record.type === "normal" && afterLoc) {
        this.next = afterLoc;
      }

      return ContinueSentinel;
    },

    finish: function(finallyLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.finallyLoc === finallyLoc) {
          this.complete(entry.completion, entry.afterLoc);
          resetTryEntry(entry);
          return ContinueSentinel;
        }
      }
    },

    "catch": function(tryLoc) {
      for (var i = this.tryEntries.length - 1; i >= 0; --i) {
        var entry = this.tryEntries[i];
        if (entry.tryLoc === tryLoc) {
          var record = entry.completion;
          if (record.type === "throw") {
            var thrown = record.arg;
            resetTryEntry(entry);
          }
          return thrown;
        }
      }

      // The context.catch method must only be called with a location
      // argument that corresponds to a known catch block.
      throw new Error("illegal catch attempt");
    },

    delegateYield: function(iterable, resultName, nextLoc) {
      this.delegate = {
        iterator: values(iterable),
        resultName: resultName,
        nextLoc: nextLoc
      };

      if (this.method === "next") {
        // Deliberately forget the last sent value so that we don't
        // accidentally pass it on to the delegate.
        this.arg = undefined;
      }

      return ContinueSentinel;
    }
  };
})(
  // In sloppy mode, unbound `this` refers to the global object, fallback to
  // Function constructor if we're in global strict mode. That is sadly a form
  // of indirect eval which violates Content Security Policy.
  (function() { return this })() || Function("return this")()
);
});

/**
 * Copyright (c) 2014-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

// This method of obtaining a reference to the global object needs to be
// kept identical to the way it is obtained in runtime.js
var g = (function() { return this })() || Function("return this")();

// Use `getOwnPropertyNames` because not all browsers support calling
// `hasOwnProperty` on the global `self` object in a worker. See #183.
var hadRuntime = g.regeneratorRuntime &&
  Object.getOwnPropertyNames(g).indexOf("regeneratorRuntime") >= 0;

// Save the old regeneratorRuntime in case it needs to be restored later.
var oldRuntime = hadRuntime && g.regeneratorRuntime;

// Force reevalutation of runtime.js.
g.regeneratorRuntime = undefined;

var runtimeModule = runtime;

if (hadRuntime) {
  // Restore the original runtime.
  g.regeneratorRuntime = oldRuntime;
} else {
  // Remove the global property added by runtime.js.
  try {
    delete g.regeneratorRuntime;
  } catch(e) {
    g.regeneratorRuntime = undefined;
  }
}

var regenerator = runtimeModule;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) {
  return typeof obj;
} : function (obj) {
  return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
};

var asyncToGenerator = function (fn) {
  return function () {
    var gen = fn.apply(this, arguments);
    return new Promise(function (resolve, reject) {
      function step(key, arg) {
        try {
          var info = gen[key](arg);
          var value = info.value;
        } catch (error) {
          reject(error);
          return;
        }

        if (info.done) {
          resolve(value);
        } else {
          return Promise.resolve(value).then(function (value) {
            step("next", value);
          }, function (err) {
            step("throw", err);
          });
        }
      }

      return step("next");
    });
  };
};

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();

var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var inherits = function (subClass, superClass) {
  if (typeof superClass !== "function" && superClass !== null) {
    throw new TypeError("Super expression must either be null or a function, not " + typeof superClass);
  }

  subClass.prototype = Object.create(superClass && superClass.prototype, {
    constructor: {
      value: subClass,
      enumerable: false,
      writable: true,
      configurable: true
    }
  });
  if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass;
};

var objectWithoutProperties = function (obj, keys) {
  var target = {};

  for (var i in obj) {
    if (keys.indexOf(i) >= 0) continue;
    if (!Object.prototype.hasOwnProperty.call(obj, i)) continue;
    target[i] = obj[i];
  }

  return target;
};

var possibleConstructorReturn = function (self, call) {
  if (!self) {
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  }

  return call && (typeof call === "object" || typeof call === "function") ? call : self;
};

var slicedToArray = function () {
  function sliceIterator(arr, i) {
    var _arr = [];
    var _n = true;
    var _d = false;
    var _e = undefined;

    try {
      for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
        _arr.push(_s.value);

        if (i && _arr.length === i) break;
      }
    } catch (err) {
      _d = true;
      _e = err;
    } finally {
      try {
        if (!_n && _i["return"]) _i["return"]();
      } finally {
        if (_d) throw _e;
      }
    }

    return _arr;
  }

  return function (arr, i) {
    if (Array.isArray(arr)) {
      return arr;
    } else if (Symbol.iterator in Object(arr)) {
      return sliceIterator(arr, i);
    } else {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }
  };
}();

var toConsumableArray = function (arr) {
  if (Array.isArray(arr)) {
    for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) arr2[i] = arr[i];

    return arr2;
  } else {
    return Array.from(arr);
  }
};

function noop() {}

function isObject(obj) {
  return (typeof obj === 'undefined' ? 'undefined' : _typeof(obj)) === 'object' && obj !== null && !Array.isArray(obj);
}

function isPromise(obj) {
  return isObject(obj) && typeof obj.then === 'function';
}

function isFunction(obj) {
  return obj && typeof obj === 'function';
}

function isNullOrUndefined(obj) {
  return obj === null || obj === undefined;
}

// from https://github.com/hughsk/flat/blob/master/index.js
function flatten() {
  var target = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

  var output = {};

  function step(obj, prev) {
    Object.keys(obj).forEach(function (key) {
      var value = obj[key];

      var newKey = prev ? prev + '.' + key : key;

      if ((isObject(value) || Array.isArray(value)) && Object.keys(value).length) {
        return step(value, newKey);
      }

      output[newKey] = value;
    });
  }

  step(target);

  return output;
}

function flattenArray(arr) {
  return [].concat.apply([], arr);
}

function concatenateErrors(errors) {
  return errors.reduce(function (acc, err) {
    var flatError = flatten(err);
    Object.keys(flatError).forEach(function (key) {
      if (!get(acc, key)) {
        // All falsey values are considered to be non-errors
        set(acc, key, flatError[key] || null);
      }
    });
    return acc;
  }, {});
}

function reduceError(errors, name) {
  return errors.reduce(function (acc, err) {
    if (!acc) {
      acc = isObject(err) ? get(err, name, null) : err;
    }
    return acc;
  }, null) || null // All falsey values are considered to be non-errors
  ;
}

function uuid(a) {
  return a ? (a ^ Math.random() * 16 >> a / 4).toString(16) : ([1e7] + -1e3 + -4e3 + -8e3 + -1e11).replace(/[018]/g, uuid);
}

var _class, _temp, _class2, _temp3;

var _createContext = createContext(),
    Provider = _createContext.Provider,
    Consumer = _createContext.Consumer;

var ReactForms = (_temp = _class = function (_Component) {
  inherits(ReactForms, _Component);

  function ReactForms(props) {
    classCallCheck(this, ReactForms);

    var _this = possibleConstructorReturn(this, (ReactForms.__proto__ || Object.getPrototypeOf(ReactForms)).call(this, props));

    _this.state = {
      fields: {},
      meta: null,
      submitCount: 0,
      isSubmitting: false,
      isValidating: false
    };
    _this.blockSubmission = false;
    _this.pendingStateUpdates = [];
    _this.flushBatchedState = debounce(function () {
      var callbacks = [];
      var newState = _this.pendingStateUpdates.reduce(function (acc, _ref) {
        var _ref2 = slicedToArray(_ref, 2),
            state = _ref2[0],
            callback = _ref2[1];

        acc = _extends({}, acc, state(acc));
        callbacks.push(callback);
        return acc;
      }, _this.state);
      _this.pendingStateUpdates = [];
      _this.setState(newState, function () {
        callbacks.forEach(function (c) {
          return c();
        });
      });
    }, 20);


    _this.registerField = _this.registerField.bind(_this);
    _this.unregisterField = _this.unregisterField.bind(_this);
    _this.setFormState = _this.setFormState.bind(_this);
    _this.setValues = _this.setValues.bind(_this);
    _this.setFieldValue = _this.setFieldValue.bind(_this);
    _this.setErrors = _this.setErrors.bind(_this);
    _this.setFieldError = _this.setFieldError.bind(_this);
    _this.setTouched = _this.setTouched.bind(_this);
    _this.setFieldTouched = _this.setFieldTouched.bind(_this);
    _this.setMeta = _this.setMeta.bind(_this);
    _this.resetForm = _this.resetForm.bind(_this);
    _this.getValues = _this.getValues.bind(_this);
    _this.getTouched = _this.getTouched.bind(_this);
    _this.getErrors = _this.getErrors.bind(_this);
    _this.runValidations = _this.runValidations.bind(_this);
    _this.executeSubmit = _this.executeSubmit.bind(_this);
    _this.submitForm = _this.submitForm.bind(_this);
    _this.getComputedProps = _this.getComputedProps.bind(_this);
    _this.getFormHelpers = _this.getFormHelpers.bind(_this);
    _this.getFormState = _this.getFormState.bind(_this);
    return _this;
  }

  createClass(ReactForms, [{
    key: 'registerField',
    value: function registerField(name, _ref3) {
      var id = _ref3.id,
          initialValue = _ref3.initialValue,
          initialTouched = _ref3.initialTouched,
          initialError = _ref3.initialError,
          validate = _ref3.validate,
          setValue = _ref3.setValue,
          setTouched = _ref3.setTouched,
          setError = _ref3.setError,
          reset = _ref3.reset;

      this.setFormState(function (prevState) {
        return _extends({}, prevState, {
          fields: _extends({}, prevState.fields, defineProperty({}, name, {
            id: id,
            initialValue: initialValue,
            value: initialValue,
            touched: initialTouched,
            error: initialError,
            validate: validate,
            setValue: setValue,
            setTouched: setTouched,
            setError: setError,
            reset: reset
          }))
        });
      });
    }
  }, {
    key: 'unregisterField',
    value: function unregisterField(id) {
      this.setFormState(function (prevState) {
        var fields = prevState.fields;


        var newFields = _extends({}, fields);

        // Find and unregister by ID so that fields can swap names
        // without then unregistering the field that swapped with them
        var name = Object.keys(newFields).find(function (fieldName) {
          if (fields[fieldName].id === id) {
            return true;
          }
        });

        if (name) {
          unset(newFields, name);

          return _extends({}, prevState, {
            fields: newFields
          });
        } else {
          return null;
        }
      });
    }
  }, {
    key: 'batchState',
    value: function batchState(state, callback) {
      this.pendingStateUpdates.push([state, callback]);
      this.flushBatchedState();
    }
  }, {
    key: 'setFormState',
    value: function setFormState(state) {
      var _this2 = this;

      return new Promise(function (resolve) {
        _this2.batchState(state, resolve);
      });
    }
  }, {
    key: 'setValues',
    value: function setValues(values) {
      var merge = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;
      var shouldValidate = arguments[2];
      var fields = this.state.fields;

      var promises = [];
      Object.keys(fields).forEach(function (name) {
        var value = get(values, name);
        if (!merge || merge && value !== undefined) {
          promises.push(fields[name].setValue(value, shouldValidate));
        }
      });
      return Promise.all(promises);
    }
  }, {
    key: 'setFieldValue',
    value: function setFieldValue(name, value, shouldValidate) {
      var fields = this.state.fields;

      if (!fields[name]) {
        throw new Error('Field ' + name + ' does not exist');
      } else {
        return fields[name].setValue(value, shouldValidate);
      }
    }
  }, {
    key: 'setErrors',
    value: function setErrors(errors) {
      var merge = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
      var shouldTouch = arguments[2];
      var fields = this.state.fields;

      var promises = [];
      Object.keys(fields).forEach(function (name) {
        var error = get(errors, name, null);
        if (!merge || merge && error === null) {
          promises.push(fields[name].setError(error, shouldTouch));
        }
      });
      return Promise.all(promises);
    }
  }, {
    key: 'setFieldError',
    value: function setFieldError(name, error, shouldTouch) {
      var fields = this.state.fields;

      if (!fields[name]) {
        throw new Error('Field ' + name + ' does not exist');
      } else {
        return fields[name].setError(error, shouldTouch);
      }
    }
  }, {
    key: 'setTouched',
    value: function setTouched(touched, shouldValidate) {
      var fields = this.state.fields;

      var promises = [];
      Object.keys(fields).forEach(function (name) {
        promises.push(fields[name].setTouched(get(touched, name, false), shouldValidate));
      });
      return Promise.all(promises);
    }
  }, {
    key: 'setFieldTouched',
    value: function setFieldTouched(name, touched, shouldValidate) {
      var fields = this.state.fields;

      if (!fields[name]) {
        throw new Error('Field ' + name + ' does not exist');
      } else {
        return fields[name].setTouched(touched, shouldValidate);
      }
    }
  }, {
    key: 'setMeta',
    value: function setMeta(meta) {
      return this.setFormState(function (prevState) {
        return _extends({}, prevState, {
          meta: meta
        });
      });
    }
  }, {
    key: 'resetForm',
    value: function resetForm(values, shouldValidate) {
      var fields = this.state.fields;

      var promises = [];
      Object.keys(fields).forEach(function (name) {
        promises.push(fields[name].reset(get(values, name), shouldValidate));
      });
      return Promise.all(promises);
    }
  }, {
    key: 'getInitialValues',
    value: function getInitialValues() {
      var fields = this.state.fields;

      return Object.keys(fields).reduce(function (acc, name) {
        set(acc, name, fields[name].initialValue);
        return acc;
      }, {});
    }
  }, {
    key: 'getValues',
    value: function getValues() {
      var fields = this.state.fields;

      return Object.keys(fields).reduce(function (acc, name) {
        set(acc, name, fields[name].value);
        return acc;
      }, {});
    }
  }, {
    key: 'getTouched',
    value: function getTouched() {
      var fields = this.state.fields;

      return Object.keys(fields).reduce(function (acc, name) {
        set(acc, name, fields[name].touched);
        return acc;
      }, {});
    }
  }, {
    key: 'getErrors',
    value: function getErrors() {
      var fields = this.state.fields;

      return Object.keys(fields).reduce(function (acc, name) {
        if (fields[name].error !== null) {
          set(acc, name, fields[name].error);
        }
        return acc;
      }, {});
    }
  }, {
    key: 'startSubmit',
    value: function startSubmit() {
      var fields = this.state.fields;


      this.setTouched(Object.keys(fields).reduce(function (acc, name) {
        set(acc, name, true);
        return acc;
      }, {}), false);

      return this.setFormState(function (prevState) {
        return _extends({}, prevState, {
          submitCount: prevState.submitCount + 1
        });
      });
    }
  }, {
    key: 'runValidations',
    value: function runValidations() {
      var _this3 = this;

      var fields = this.state.fields;
      var validate = this.props.validate;


      var values = this.getValues();

      this.setFormState(function (prevState) {
        return _extends({}, prevState, {
          isValidating: true
        });
      });

      var asyncValidators = [];
      var syncErrors = [];

      // Validate all fields then the form
      // If both have validated the same field use
      // the field specific error

      // If there are async validators then overwrite
      // the sync errors with those
      Object.keys(fields).forEach(function (name) {
        var fieldValidator = fields[name].validate;

        if (isFunction(fieldValidator)) {
          var maybePromisedError = fieldValidator(fields[name].value, _this3.getFormHelpers(true));

          if (isPromise(maybePromisedError)) {
            asyncValidators.push(defineProperty({}, name, maybePromisedError));
          } else {
            syncErrors.push(defineProperty({}, name, maybePromisedError));
          }
        } else {
          // Make sure every error has a null value if
          // no validation is performed
          syncErrors.push(defineProperty({}, name, null));
        }
      });

      if (isFunction(validate)) {
        var maybePromisedErrors = validate(values, this.getFormHelpers(true));

        if (isPromise(maybePromisedErrors)) {
          asyncValidators.push(maybePromisedErrors);
        } else {
          syncErrors.push(maybePromisedErrors);
        }
      }

      if (asyncValidators.length === 0) {
        this.setFormState(function (prevState) {
          return _extends({}, prevState, {
            isValidating: false
          });
        });
        return concatenateErrors(syncErrors);
      } else {
        // Wrap this in a promise to be able to control the
        // resolved value so we can preserve the field name
        // that the error is attached to
        return new Promise(function () {
          var _ref4 = asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee2(resolve) {
            var asyncErrors;
            return regenerator.wrap(function _callee2$(_context2) {
              while (1) {
                switch (_context2.prev = _context2.next) {
                  case 0:
                    _context2.next = 2;
                    return Promise.all(flattenArray(asyncValidators.map(function (validator) {
                      if (!isPromise(validator)) {
                        return Object.entries(validator).map(function (_ref5) {
                          var _ref6 = slicedToArray(_ref5, 2),
                              key = _ref6[0],
                              value = _ref6[1];

                          return new Promise(function () {
                            var _ref7 = asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee(resolve) {
                              var error;
                              return regenerator.wrap(function _callee$(_context) {
                                while (1) {
                                  switch (_context.prev = _context.next) {
                                    case 0:
                                      _context.next = 2;
                                      return value;

                                    case 2:
                                      error = _context.sent;

                                      resolve(defineProperty({}, key, error));

                                    case 4:
                                    case 'end':
                                      return _context.stop();
                                  }
                                }
                              }, _callee, _this3);
                            }));

                            return function (_x4) {
                              return _ref7.apply(this, arguments);
                            };
                          }());
                        });
                      } else {
                        return validator;
                      }
                    })));

                  case 2:
                    asyncErrors = _context2.sent;

                    _this3.setFormState(function (prevState) {
                      return _extends({}, prevState, {
                        isValidating: false
                      });
                    });
                    resolve(_extends({}, concatenateErrors([].concat(syncErrors, toConsumableArray(asyncErrors)))));

                  case 5:
                  case 'end':
                    return _context2.stop();
                }
              }
            }, _callee2, _this3);
          }));

          return function (_x3) {
            return _ref4.apply(this, arguments);
          };
        }());
      }
    }
  }, {
    key: 'executeSubmit',
    value: function () {
      var _ref8 = asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee3() {
        var handleSubmit, values, errors, isValid, submit, submission;
        return regenerator.wrap(function _callee3$(_context3) {
          while (1) {
            switch (_context3.prev = _context3.next) {
              case 0:
                handleSubmit = this.props.handleSubmit;
                _context3.prev = 1;
                values = this.getValues();
                errors = this.getErrors();
                isValid = Object.keys(errors).length <= 0;

                if (!isValid) {
                  _context3.next = 14;
                  break;
                }

                this.setFormState(function (prevState) {
                  return _extends({}, prevState, {
                    isSubmitting: true
                  });
                });
                submit = handleSubmit(values, this.getFormHelpers(true));

                if (!isPromise(submit)) {
                  _context3.next = 13;
                  break;
                }

                _context3.next = 11;
                return submit;

              case 11:
                submission = _context3.sent;
                return _context3.abrupt('return', submission);

              case 13:
                return _context3.abrupt('return', submit);

              case 14:
                return _context3.abrupt('return', false);

              case 15:
                _context3.prev = 15;
                _context3.next = 18;
                return this.setFormState(function (prevState) {
                  return _extends({}, prevState, {
                    isSubmitting: false
                  });
                });

              case 18:
                return _context3.finish(15);

              case 19:
              case 'end':
                return _context3.stop();
            }
          }
        }, _callee3, this, [[1,, 15, 19]]);
      }));

      function executeSubmit() {
        return _ref8.apply(this, arguments);
      }

      return executeSubmit;
    }()
  }, {
    key: 'submitForm',
    value: function () {
      var _ref9 = asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee4(e) {
        var isSubmitting, maybePromisedErrors, errors;
        return regenerator.wrap(function _callee4$(_context4) {
          while (1) {
            switch (_context4.prev = _context4.next) {
              case 0:
                isSubmitting = this.state.isSubmitting;


                if (e && e.preventDefault) {
                  e.preventDefault();
                }

                if (!(isSubmitting || this.blockSubmission)) {
                  _context4.next = 4;
                  break;
                }

                return _context4.abrupt('return', false);

              case 4:

                this.blockSubmission = true;
                _context4.prev = 5;
                _context4.next = 8;
                return this.startSubmit();

              case 8:
                maybePromisedErrors = this.runValidations();

                if (!isPromise(maybePromisedErrors)) {
                  _context4.next = 17;
                  break;
                }

                _context4.next = 12;
                return maybePromisedErrors;

              case 12:
                errors = _context4.sent;
                _context4.next = 15;
                return this.setErrors(errors, false, true);

              case 15:
                _context4.next = 19;
                break;

              case 17:
                _context4.next = 19;
                return this.setErrors(maybePromisedErrors, false, true);

              case 19:
                _context4.next = 21;
                return this.executeSubmit();

              case 21:
                return _context4.abrupt('return', _context4.sent);

              case 22:
                _context4.prev = 22;

                this.blockSubmission = false;
                return _context4.finish(22);

              case 25:
              case 'end':
                return _context4.stop();
            }
          }
        }, _callee4, this, [[5,, 22, 25]]);
      }));

      function submitForm(_x5) {
        return _ref9.apply(this, arguments);
      }

      return submitForm;
    }()
  }, {
    key: 'getComputedProps',
    value: function getComputedProps() {
      var initialValues = this.getInitialValues();
      var values = this.getValues();
      var errors = this.getErrors();

      return {
        isDirty: !isEqual(initialValues, values),
        isValid: Object.keys(errors).length <= 0
      };
    }
  }, {
    key: 'getFormHelpers',
    value: function getFormHelpers(withProps) {
      var _state = this.state,
          meta = _state.meta,
          submitCount = _state.submitCount;
      var outerProps = this.props.outerProps;

      return _extends({}, outerProps && withProps ? { props: outerProps } : {}, {
        meta: meta,
        submitCount: submitCount,
        setValues: this.setValues,
        setFieldValue: this.setFieldValue,
        setErrors: this.setErrors,
        setFieldError: this.setFieldError,
        setTouched: this.setTouched,
        setFieldTouched: this.setFieldTouched,
        setMeta: this.setMeta,
        resetForm: this.resetForm,
        submitForm: this.submitForm
      });
    }
  }, {
    key: 'getFormState',
    value: function getFormState() {
      var _state2 = this.state,
          fields = _state2.fields,
          meta = _state2.meta,
          submitCount = _state2.submitCount,
          restState = objectWithoutProperties(_state2, ['fields', 'meta', 'submitCount']);


      return _extends({}, this.getComputedProps(), this.getFormHelpers(false), restState, {
        values: this.getValues(),
        touched: this.getTouched(),
        errors: this.getErrors()
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          render = _props.render,
          children = _props.children,
          validate = _props.validate,
          initialValues = _props.initialValues,
          validateOnMount = _props.validateOnMount,
          validateOnChange = _props.validateOnChange,
          validateOnBlur = _props.validateOnBlur,
          touchOnMount = _props.touchOnMount,
          touchOnChange = _props.touchOnChange,
          touchOnBlur = _props.touchOnBlur,
          shouldUnregister = _props.shouldUnregister;


      var formState = this.getFormState();

      return React__default.createElement(
        Provider,
        {
          value: _extends({}, formState, {
            initialValues: initialValues,
            validateOnMount: validateOnMount,
            validateOnChange: validateOnChange,
            validateOnBlur: validateOnBlur,
            touchOnMount: touchOnMount,
            touchOnChange: touchOnChange,
            touchOnBlur: touchOnBlur,
            shouldUnregister: shouldUnregister,
            registerField: this.registerField,
            unregisterField: this.unregisterField,
            validateForm: validate,
            setFormState: this.setFormState,
            getFormHelpers: this.getFormHelpers
          })
        },
        isFunction(children) ? children(formState) : isFunction(render) ? render(formState) : null
      );
    }
  }]);
  return ReactForms;
}(React.Component), _class.defaultProps = {
  validateOnMount: false,
  validateOnChange: true,
  validateOnBlur: true,
  touchOnMount: false,
  touchOnChange: true,
  touchOnBlur: true,
  shouldUnregister: true,
  handleSubmit: noop
}, _temp);
var AsyncValuesWrapper = (_temp3 = _class2 = function (_Component2) {
  inherits(AsyncValuesWrapper, _Component2);

  function AsyncValuesWrapper() {
    var _ref10;

    var _temp2, _this4, _ret;

    classCallCheck(this, AsyncValuesWrapper);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp2 = (_this4 = possibleConstructorReturn(this, (_ref10 = AsyncValuesWrapper.__proto__ || Object.getPrototypeOf(AsyncValuesWrapper)).call.apply(_ref10, [this].concat(args))), _this4), _this4.initialized = _this4.getAsyncValuesReady(), _this4.getKey = function () {
      if (!_this4.initialized) {
        if (_this4.getAsyncValuesReady()) {
          _this4.initialized = true;
        } else {
          return false;
        }
      }
      return _this4.initialized;
    }, _temp2), possibleConstructorReturn(_this4, _ret);
  }

  createClass(AsyncValuesWrapper, [{
    key: 'getAsyncValuesReady',
    value: function getAsyncValuesReady() {
      var _props2 = this.props,
          asyncValuesReady = _props2.asyncValuesReady,
          outerProps = _props2.outerProps;

      if (isFunction(asyncValuesReady)) {
        return asyncValuesReady(outerProps);
      } else {
        return asyncValuesReady;
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          asyncValuesReady = _props3.asyncValuesReady,
          rest = objectWithoutProperties(_props3, ['asyncValuesReady']);


      return React__default.createElement(ReactForms, _extends({ key: this.getKey() }, rest));
    }
  }]);
  return AsyncValuesWrapper;
}(React.Component), _class2.defaultProps = {
  asyncValuesReady: true
}, _temp3);


var FormConsumer = Consumer;

function withContext(WrappedComponent) {
  return function (props) {
    return React__default.createElement(
      FormConsumer,
      null,
      function (reactForms) {
        return React__default.createElement(WrappedComponent, _extends({}, props, { reactForms: reactForms }));
      }
    );
  };
}

var _class$1;

var Form = withContext(_class$1 = function (_Component) {
  inherits(Form, _Component);

  function Form() {
    classCallCheck(this, Form);
    return possibleConstructorReturn(this, (Form.__proto__ || Object.getPrototypeOf(Form)).apply(this, arguments));
  }

  createClass(Form, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          submitForm = _props.reactForms.submitForm,
          rest = objectWithoutProperties(_props, ['reactForms']);

      return React__default.createElement('form', _extends({ onSubmit: submitForm }, rest));
    }
  }]);
  return Form;
}(React.Component)) || _class$1;

var _class$2, _class2$1, _temp$1;

var Field = withContext(_class$2 = (_temp$1 = _class2$1 = function (_Component) {
  inherits(Field, _Component);

  function Field(props) {
    classCallCheck(this, Field);
    var name = props.name,
        initialValue = props.initialValue,
        shouldUnregister = props.shouldUnregister,
        _props$reactForms = props.reactForms,
        currentValues = _props$reactForms.values,
        currentTouched = _props$reactForms.touched,
        currentErrors = _props$reactForms.errors,
        initialValues = _props$reactForms.initialValues,
        touchOnMount = _props$reactForms.touchOnMount,
        formShouldUnregister = _props$reactForms.shouldUnregister,
        registerField = _props$reactForms.registerField;

    var _this = possibleConstructorReturn(this, (Field.__proto__ || Object.getPrototypeOf(Field)).call(this, props));

    var formInitialValue = get(initialValues, name);

    var currentFormValue = get(currentValues, name);
    var currentFormTouched = get(currentTouched, name);
    var currentFormError = get(currentErrors, name);

    var value = !isNullOrUndefined(currentFormValue) ? currentFormValue : !isNullOrUndefined(initialValue) ? initialValue : !isNullOrUndefined(formInitialValue) ? formInitialValue : '';
    var touched = !isNullOrUndefined(currentFormTouched) ? currentFormTouched : !!touchOnMount;
    var error = !isNullOrUndefined(currentFormError) ? currentFormError : null;

    _this.state = {
      value: value,
      touched: touched,
      error: error,
      focused: false,
      initialValue: value,
      isValidating: false
    };

    _this.id = uuid();
    _this.mounted = false;
    _this.shouldUnregister = !isNullOrUndefined(shouldUnregister) ? shouldUnregister : formShouldUnregister;

    registerField(name, _extends({
      id: _this.id,
      initialValue: value,
      initialTouched: touched,
      initialError: error
    }, _this.getRegistrations()));

    _this.setFieldState = _this.setFieldState.bind(_this);
    _this.getRegistrations = _this.getRegistrations.bind(_this);
    _this.handleValidate = _this.handleValidate.bind(_this);
    _this.handleFocus = _this.handleFocus.bind(_this);
    _this.handleChange = _this.handleChange.bind(_this);
    _this.handleBlur = _this.handleBlur.bind(_this);
    _this.getFieldProps = _this.getFieldProps.bind(_this);
    return _this;
  }

  createClass(Field, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var _props = this.props,
          name = _props.name,
          children = _props.children,
          render = _props.render,
          InputComponent = _props.Component,
          initialValue = _props.initialValue,
          reactForms = _props.reactForms,
          sendImmediate = _props.sendImmediate,
          shouldUnregister = _props.shouldUnregister,
          validate = _props.validate,
          onFocus = _props.onFocus,
          onChange = _props.onChange,
          onBlur = _props.onBlur,
          rest = objectWithoutProperties(_props, ['name', 'children', 'render', 'Component', 'initialValue', 'reactForms', 'sendImmediate', 'shouldUnregister', 'validate', 'onFocus', 'onChange', 'onBlur']);
      var newName = nextProps.name,
          newChildren = nextProps.children,
          newRender = nextProps.render,
          NewInputComponent = nextProps.Component,
          newInitialValue = nextProps.initialValue,
          newReactForms = nextProps.reactForms,
          newSendImmediate = nextProps.sendImmediate,
          newShouldUnregister = nextProps.shouldUnregister,
          newValidate = nextProps.validate,
          newOnFocus = nextProps.onFocus,
          newOnChange = nextProps.onChange,
          newOnBlur = nextProps.onBlur,
          newRest = objectWithoutProperties(nextProps, ['name', 'children', 'render', 'Component', 'initialValue', 'reactForms', 'sendImmediate', 'shouldUnregister', 'validate', 'onFocus', 'onChange', 'onBlur']);


      if (this.state !== nextState) {
        return true;
      }
      if (name !== newName || children !== newChildren || render !== newRender || InputComponent !== NewInputComponent) {
        return true;
      }
      if (!isEqual(rest, newRest)) {
        return true;
      }

      return false;
    }
  }, {
    key: 'getRegistrations',
    value: function getRegistrations() {
      var _this2 = this;

      var _props2 = this.props,
          validate = _props2.validate,
          _props2$reactForms = _props2.reactForms,
          validateOnMount = _props2$reactForms.validateOnMount,
          validateOnChange = _props2$reactForms.validateOnChange,
          validateOnBlur = _props2$reactForms.validateOnBlur,
          touchOnMount = _props2$reactForms.touchOnMount;


      return {
        validate: validate,
        setValue: function setValue(value) {
          var shouldValidate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : validateOnChange;

          return new Promise(function () {
            var _ref = asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee(resolve) {
              var promises, error;
              return regenerator.wrap(function _callee$(_context) {
                while (1) {
                  switch (_context.prev = _context.next) {
                    case 0:
                      promises = [_this2.setFieldState(function (prevState) {
                        return _extends({}, prevState, {
                          value: value
                        });
                      }), _this2.sendValue(value)];

                      if (!shouldValidate) {
                        _context.next = 14;
                        break;
                      }

                      error = _this2.handleValidate(value);

                      if (!isPromise(error)) {
                        _context.next = 13;
                        break;
                      }

                      _context.t0 = promises;
                      _context.t1 = _this2;
                      _context.next = 8;
                      return error;

                    case 8:
                      _context.t2 = _context.sent;
                      _context.t3 = _context.t1.sendError.call(_context.t1, _context.t2);

                      _context.t0.push.call(_context.t0, _context.t3);

                      _context.next = 14;
                      break;

                    case 13:
                      promises.push(_this2.sendError(error));

                    case 14:
                      _context.next = 16;
                      return Promise.all(promises);

                    case 16:

                      resolve(value);

                    case 17:
                    case 'end':
                      return _context.stop();
                  }
                }
              }, _callee, _this2);
            }));

            return function (_x2) {
              return _ref.apply(this, arguments);
            };
          }());
        },
        setError: function setError(error) {
          var shouldTouch = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : true;

          return new Promise(function () {
            var _ref2 = asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee2(resolve) {
              var promises;
              return regenerator.wrap(function _callee2$(_context2) {
                while (1) {
                  switch (_context2.prev = _context2.next) {
                    case 0:
                      promises = [_this2.setFieldState(function (prevState) {
                        return _extends({}, prevState, {
                          error: error,
                          touched: !!shouldTouch
                        });
                      })];

                      if (shouldTouch) {
                        promises.push(_this2.sendTouched(shouldTouch));
                      }
                      promises.push(_this2.sendError(error));

                      _context2.next = 5;
                      return Promise.all(promises);

                    case 5:

                      resolve(error);

                    case 6:
                    case 'end':
                      return _context2.stop();
                  }
                }
              }, _callee2, _this2);
            }));

            return function (_x4) {
              return _ref2.apply(this, arguments);
            };
          }());
        },
        setTouched: function setTouched(touched) {
          var shouldValidate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : validateOnBlur;

          return new Promise(function () {
            var _ref3 = asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee3(resolve) {
              var value, promises, error;
              return regenerator.wrap(function _callee3$(_context3) {
                while (1) {
                  switch (_context3.prev = _context3.next) {
                    case 0:
                      value = _this2.state.value;
                      promises = [_this2.setFieldState(function (prevState) {
                        return _extends({}, prevState, {
                          touched: touched
                        });
                      }), _this2.sendTouched(touched)];

                      if (!shouldValidate) {
                        _context3.next = 15;
                        break;
                      }

                      error = _this2.handleValidate(value);

                      if (!isPromise(error)) {
                        _context3.next = 14;
                        break;
                      }

                      _context3.t0 = promises;
                      _context3.t1 = _this2;
                      _context3.next = 9;
                      return error;

                    case 9:
                      _context3.t2 = _context3.sent;
                      _context3.t3 = _context3.t1.sendError.call(_context3.t1, _context3.t2);

                      _context3.t0.push.call(_context3.t0, _context3.t3);

                      _context3.next = 15;
                      break;

                    case 14:
                      promises.push(_this2.sendError(error));

                    case 15:
                      _context3.next = 17;
                      return Promise.all(promises);

                    case 17:

                      resolve(touched);

                    case 18:
                    case 'end':
                      return _context3.stop();
                  }
                }
              }, _callee3, _this2);
            }));

            return function (_x6) {
              return _ref3.apply(this, arguments);
            };
          }());
        },
        reset: function reset(val) {
          var shouldValidate = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : validateOnMount;

          return new Promise(function () {
            var _ref4 = asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee4(resolve) {
              var initialValue, value, touched, maybePromisedError, promises, error;
              return regenerator.wrap(function _callee4$(_context4) {
                while (1) {
                  switch (_context4.prev = _context4.next) {
                    case 0:
                      initialValue = _this2.state.initialValue;
                      value = !isNullOrUndefined(val) ? val : initialValue;
                      touched = shouldValidate && !!touchOnMount;
                      maybePromisedError = shouldValidate && _this2.handleValidate(value) || null;
                      promises = [_this2.setFieldState(function (prevState) {
                        return _extends({}, prevState, {
                          value: value,
                          touched: touched,
                          initialValue: value
                        });
                      }), _this2.sendInitialValue(value), _this2.sendValue(value), _this2.sendTouched(touched)];

                      if (!isPromise(maybePromisedError)) {
                        _context4.next = 15;
                        break;
                      }

                      _context4.next = 8;
                      return maybePromisedError;

                    case 8:
                      error = _context4.sent;


                      promises.push(_this2.sendError(error));

                      _context4.next = 12;
                      return Promise.all(promises);

                    case 12:

                      resolve({
                        value: value,
                        touched: touched,
                        error: error
                      });
                      _context4.next = 19;
                      break;

                    case 15:
                      promises.push(_this2.sendError(maybePromisedError));

                      _context4.next = 18;
                      return Promise.all(promises);

                    case 18:

                      resolve({
                        value: value,
                        touched: touched,
                        error: maybePromisedError
                      });

                    case 19:
                    case 'end':
                      return _context4.stop();
                  }
                }
              }, _callee4, _this2);
            }));

            return function (_x8) {
              return _ref4.apply(this, arguments);
            };
          }());
        }
      };
    }
  }, {
    key: 'setFieldState',
    value: function setFieldState(state) {
      var _this3 = this;

      return new Promise(function (resolve) {
        if (_this3.mounted) {
          _this3.setState(state, resolve);
        } else {
          resolve();
        }
      });
    }
  }, {
    key: 'componentDidMount',
    value: function () {
      var _ref5 = asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee5() {
        var value, validateOnMount, maybePromisedError;
        return regenerator.wrap(function _callee5$(_context5) {
          while (1) {
            switch (_context5.prev = _context5.next) {
              case 0:
                value = this.state.value;
                validateOnMount = this.props.reactForms.validateOnMount;


                this.mounted = true;

                if (!validateOnMount) {
                  _context5.next = 14;
                  break;
                }

                maybePromisedError = this.handleValidate(value);

                if (!isPromise(maybePromisedError)) {
                  _context5.next = 13;
                  break;
                }

                _context5.t0 = this;
                _context5.next = 9;
                return maybePromisedError;

              case 9:
                _context5.t1 = _context5.sent;

                _context5.t0.sendError.call(_context5.t0, _context5.t1);

                _context5.next = 14;
                break;

              case 13:
                this.sendError(maybePromisedError);

              case 14:
              case 'end':
                return _context5.stop();
            }
          }
        }, _callee5, this);
      }));

      function componentDidMount() {
        return _ref5.apply(this, arguments);
      }

      return componentDidMount;
    }()
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate(prevProps) {
      var _state = this.state,
          value = _state.value,
          touched = _state.touched,
          error = _state.error;
      var _props3 = this.props,
          name = _props3.name,
          shouldUnregister = _props3.shouldUnregister,
          _props3$reactForms = _props3.reactForms,
          formShouldUnregister = _props3$reactForms.shouldUnregister,
          registerField = _props3$reactForms.registerField,
          unregisterField = _props3$reactForms.unregisterField;
      var prevName = prevProps.name,
          prevShouldUnregister = prevProps.shouldUnregister;


      if (shouldUnregister !== prevShouldUnregister) {
        this.shouldUnregister = !isNullOrUndefined(shouldUnregister) ? shouldUnregister : formShouldUnregister;
      }

      if (name !== prevName) {
        if (this.shouldUnregister) {
          unregisterField(this.id);
        }
        registerField(name, _extends({
          id: this.id,
          initialValue: value,
          initialTouched: touched,
          initialError: error
        }, this.getRegistrations()));
      }
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      var unregisterField = this.props.reactForms.unregisterField;


      this.mounted = false;

      if (this.shouldUnregister) {
        unregisterField(this.id);
      }
    }
  }, {
    key: 'sendInitialValue',
    value: function sendInitialValue(value) {
      var _props4 = this.props,
          name = _props4.name,
          setFormState = _props4.reactForms.setFormState;


      return setFormState(function (prevState) {
        return _extends({}, prevState, {
          fields: _extends({}, prevState.fields, defineProperty({}, name, set(_extends({}, prevState.fields[name]), 'initialValue', value)))
        });
      });
    }
  }, {
    key: 'sendValue',
    value: function sendValue(value) {
      var _props5 = this.props,
          name = _props5.name,
          setFormState = _props5.reactForms.setFormState;


      return setFormState(function (prevState) {
        return _extends({}, prevState, {
          fields: _extends({}, prevState.fields, defineProperty({}, name, set(_extends({}, prevState.fields[name]), 'value', value)))
        });
      });
    }
  }, {
    key: 'sendTouched',
    value: function sendTouched(touched) {
      var _props6 = this.props,
          name = _props6.name,
          setFormState = _props6.reactForms.setFormState;


      return setFormState(function (prevState) {
        return _extends({}, prevState, {
          fields: _extends({}, prevState.fields, defineProperty({}, name, set(_extends({}, prevState.fields[name]), 'touched', touched)))
        });
      });
    }
  }, {
    key: 'sendError',
    value: function sendError(error) {
      var _props7 = this.props,
          name = _props7.name,
          setFormState = _props7.reactForms.setFormState;


      return setFormState(function (prevState) {
        return _extends({}, prevState, {
          fields: _extends({}, prevState.fields, defineProperty({}, name, set(_extends({}, prevState.fields[name]), 'error', error)))
        });
      });
    }
  }, {
    key: 'handleValidate',
    value: function handleValidate(value) {
      var _this4 = this;

      var _props8 = this.props,
          name = _props8.name,
          validate = _props8.validate,
          _props8$reactForms = _props8.reactForms,
          formValues = _props8$reactForms.values,
          validateForm = _props8$reactForms.validateForm,
          getFormHelpers = _props8$reactForms.getFormHelpers;

      // Run both field level and form level validations
      // to make sure that all possible errors are accounted for
      // Always use the first error found

      var asyncValidators = [];
      var syncErrors = [];

      if (isFunction(validate)) {
        var maybePromisedError = validate(value, getFormHelpers(true)) || null;
        if (isPromise(maybePromisedError)) {
          asyncValidators.push(maybePromisedError);
        } else {
          syncErrors.push(maybePromisedError);
        }
      }

      if (isFunction(validateForm)) {
        var values = set(_extends({}, formValues), name, value);
        var maybePromisedErrors = validateForm(values, getFormHelpers(true));

        if (isPromise(maybePromisedErrors)) {
          asyncValidators.push(maybePromisedErrors);
        } else {
          var error = get(maybePromisedErrors, name, null);
          syncErrors.push(error);
        }
      }

      var reducedSyncError = reduceError(syncErrors, name);

      // Either return a promise that resolves to the error
      // or just the error so we can make as few updates as possible
      if (reducedSyncError) {
        this.setFieldState(function (prevState) {
          return _extends({}, prevState, {
            error: reducedSyncError
          });
        });
        return reducedSyncError;
      } else if (asyncValidators.length !== 0) {
        return new Promise(function () {
          var _ref6 = asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee6(resolve) {
            var error;
            return regenerator.wrap(function _callee6$(_context6) {
              while (1) {
                switch (_context6.prev = _context6.next) {
                  case 0:
                    _context6.next = 2;
                    return _this4.setFieldState(function (prevState) {
                      return _extends({}, prevState, {
                        isValidating: true
                      });
                    });

                  case 2:
                    _context6.t0 = reduceError;
                    _context6.next = 5;
                    return Promise.all(asyncValidators);

                  case 5:
                    _context6.t1 = _context6.sent;
                    _context6.t2 = name;
                    error = (0, _context6.t0)(_context6.t1, _context6.t2);
                    _context6.next = 10;
                    return _this4.setFieldState(function (prevState) {
                      return _extends({}, prevState, {
                        error: error,
                        isValidating: false
                      });
                    });

                  case 10:

                    resolve(error);

                  case 11:
                  case 'end':
                    return _context6.stop();
                }
              }
            }, _callee6, _this4);
          }));

          return function (_x9) {
            return _ref6.apply(this, arguments);
          };
        }());
      }

      // If no validation then set error to null
      this.setFieldState(function (prevState) {
        return _extends({}, prevState, {
          error: null
        });
      });
      return null;
    }
  }, {
    key: 'handleFocus',
    value: function handleFocus(e) {
      var onFocus = this.props.onFocus;


      if (isObject(e) && e.persist) {
        e.persist();
      }

      onFocus(e);

      this.setFieldState(function (prevState) {
        return _extends({}, prevState, {
          focused: true
        });
      });
    }
  }, {
    key: 'handleChange',
    value: function () {
      var _ref7 = asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee7(e) {
        var _state2, focused, touched, _props9, onChange, sendImmediate, _props9$reactForms, validateOnChange, touchOnChange, type, value, maybePromisedError;

        return regenerator.wrap(function _callee7$(_context7) {
          while (1) {
            switch (_context7.prev = _context7.next) {
              case 0:
                _state2 = this.state, focused = _state2.focused, touched = _state2.touched;
                _props9 = this.props, onChange = _props9.onChange, sendImmediate = _props9.sendImmediate, _props9$reactForms = _props9.reactForms, validateOnChange = _props9$reactForms.validateOnChange, touchOnChange = _props9$reactForms.touchOnChange;


                if (isObject(e) && e.persist) {
                  e.persist();
                }

                type = e.target.type;
                value = type === 'checkbox' ? e.target.checked : type === 'file' ? e.target.files : e.target.value;


                onChange(e);

                this.setFieldState(function (prevState) {
                  return _extends({}, prevState, {
                    value: value,
                    touched: touched || !!touchOnChange
                  });
                });

                if (sendImmediate || !focused) {
                  this.sendValue(value);
                  this.sendTouched(touched || !!touchOnChange);
                }

                if (!validateOnChange) {
                  _context7.next = 20;
                  break;
                }

                maybePromisedError = this.handleValidate(value);

                if (!isPromise(maybePromisedError)) {
                  _context7.next = 19;
                  break;
                }

                if (!(sendImmediate || !focused)) {
                  _context7.next = 17;
                  break;
                }

                _context7.t0 = this;
                _context7.next = 15;
                return maybePromisedError;

              case 15:
                _context7.t1 = _context7.sent;

                _context7.t0.sendError.call(_context7.t0, _context7.t1);

              case 17:
                _context7.next = 20;
                break;

              case 19:
                if (sendImmediate || !focused) {
                  this.sendError(maybePromisedError);
                }

              case 20:
              case 'end':
                return _context7.stop();
            }
          }
        }, _callee7, this);
      }));

      function handleChange(_x10) {
        return _ref7.apply(this, arguments);
      }

      return handleChange;
    }()
  }, {
    key: 'handleBlur',
    value: function () {
      var _ref8 = asyncToGenerator( /*#__PURE__*/regenerator.mark(function _callee8(e) {
        var _state3, value, touched, error, _props10, onBlur, _props10$reactForms, validateOnBlur, touchOnBlur, maybePromisedError;

        return regenerator.wrap(function _callee8$(_context8) {
          while (1) {
            switch (_context8.prev = _context8.next) {
              case 0:
                _state3 = this.state, value = _state3.value, touched = _state3.touched, error = _state3.error;
                _props10 = this.props, onBlur = _props10.onBlur, _props10$reactForms = _props10.reactForms, validateOnBlur = _props10$reactForms.validateOnBlur, touchOnBlur = _props10$reactForms.touchOnBlur;


                if (isObject(e) && e.persist) {
                  e.persist();
                }

                onBlur(e);

                this.setFieldState(function (prevState) {
                  return _extends({}, prevState, {
                    touched: touched || !!touchOnBlur,
                    focused: false
                  });
                });

                this.sendValue(value);
                this.sendTouched(touched || !!touchOnBlur);

                if (!validateOnBlur) {
                  _context8.next = 20;
                  break;
                }

                maybePromisedError = this.handleValidate(value);

                if (!isPromise(maybePromisedError)) {
                  _context8.next = 17;
                  break;
                }

                _context8.t0 = this;
                _context8.next = 13;
                return maybePromisedError;

              case 13:
                _context8.t1 = _context8.sent;

                _context8.t0.sendError.call(_context8.t0, _context8.t1);

                _context8.next = 18;
                break;

              case 17:
                this.sendError(maybePromisedError);

              case 18:
                _context8.next = 21;
                break;

              case 20:
                this.sendError(error);

              case 21:
              case 'end':
                return _context8.stop();
            }
          }
        }, _callee8, this);
      }));

      function handleBlur(_x11) {
        return _ref8.apply(this, arguments);
      }

      return handleBlur;
    }()
  }, {
    key: 'getFieldProps',
    value: function getFieldProps() {
      var _state4 = this.state,
          value = _state4.value,
          touched = _state4.touched,
          error = _state4.error,
          focused = _state4.focused,
          initialValue = _state4.initialValue,
          isValidating = _state4.isValidating;
      var name = this.props.name;


      return {
        id: this.id,
        name: name,
        value: value,
        meta: {
          error: error,
          touched: touched,
          focused: focused,
          initialValue: initialValue,
          isValidating: isValidating
        },
        onFocus: this.handleFocus,
        onChange: this.handleChange,
        onBlur: this.handleBlur
      };
    }
  }, {
    key: 'render',
    value: function render() {
      var _getFieldProps = this.getFieldProps(),
          meta = _getFieldProps.meta,
          restField = objectWithoutProperties(_getFieldProps, ['meta']);

      var _props11 = this.props,
          initialValue = _props11.initialValue,
          reactForms = _props11.reactForms,
          sendImmediate = _props11.sendImmediate,
          shouldUnregister = _props11.shouldUnregister,
          InputComponent = _props11.Component,
          children = _props11.children,
          render = _props11.render,
          validate = _props11.validate,
          onFocus = _props11.onFocus,
          onChange = _props11.onChange,
          onBlur = _props11.onBlur,
          restProps = objectWithoutProperties(_props11, ['initialValue', 'reactForms', 'sendImmediate', 'shouldUnregister', 'Component', 'children', 'render', 'validate', 'onFocus', 'onChange', 'onBlur']);


      var props = _extends({}, restProps, {
        field: _extends({}, restField),
        meta: meta
      });

      return isFunction(children) ? children(props) : isFunction(render) ? render(props) : isFunction(InputComponent) ? React__default.createElement(InputComponent, props) : InputComponent ? React__default.createElement(InputComponent, restField) : null;
    }
  }]);
  return Field;
}(React.Component), _class2$1.defaultProps = {
  sendImmediate: false,
  Component: 'input',
  onFocus: noop,
  onChange: noop,
  onBlur: noop
}, _temp$1)) || _class$2;

var _class$3, _temp$2;

var _push = function _push() {
  var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var field = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var copy = [].concat(toConsumableArray(array));
  copy.push(_extends({ id: uuid() }, field));
  return copy;
};

var _pop = function _pop() {
  var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

  var copy = [].concat(toConsumableArray(array));
  copy.pop();
  return copy;
};

var _unshift = function _unshift() {
  var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var field = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

  var copy = [].concat(toConsumableArray(array));
  copy.unshift(_extends({ id: uuid() }, field));
  return copy;
};

var _swap = function _swap() {
  var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var indexA = arguments[1];
  var indexB = arguments[2];

  var copy = [].concat(toConsumableArray(array));
  var a = copy[indexA];
  copy[indexA] = copy[indexB];
  copy[indexB] = a;
  return copy;
};

var _move = function _move() {
  var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var from = arguments[1];
  var to = arguments[2];

  var copy = [].concat(toConsumableArray(array));
  var value = copy[from];
  copy.splice(from, 1);
  copy.splice(to, 0, value);
  return copy;
};

var _insert = function _insert() {
  var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var index = arguments[1];
  var field = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var copy = [].concat(toConsumableArray(array));
  copy.splice(index, 0, _extends({ id: uuid() }, field));
  return copy;
};

var _replace = function _replace() {
  var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var index = arguments[1];
  var field = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

  var copy = [].concat(toConsumableArray(array));
  copy[index] = _extends({ id: uuid() }, field);
  return copy;
};

var _remove = function _remove() {
  var array = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
  var index = arguments[1];

  return [].concat(toConsumableArray(array.slice(0, index)), toConsumableArray(array.slice(index + 1, array.length)));
};

var FieldArray = (_temp$2 = _class$3 = function (_Component) {
  inherits(FieldArray, _Component);

  function FieldArray(props) {
    classCallCheck(this, FieldArray);

    var _this = possibleConstructorReturn(this, (FieldArray.__proto__ || Object.getPrototypeOf(FieldArray)).call(this, props));

    _this.state = {
      fields: _this.props.initialFields.map(function (field) {
        return _extends({ id: uuid() }, field);
      })
    };

    _this.fieldArrayState = {
      push: _this.push.bind(_this),
      pop: _this.pop.bind(_this),
      unshift: _this.unshift.bind(_this),
      swap: _this.swap.bind(_this),
      move: _this.move.bind(_this),
      insert: _this.insert.bind(_this),
      replace: _this.replace.bind(_this),
      remove: _this.remove.bind(_this),
      getFieldProps: _this.getFieldProps.bind(_this)
    };
    return _this;
  }

  createClass(FieldArray, [{
    key: 'push',
    value: function push(field) {
      this.setState(function (prevState) {
        return _extends({}, prevState, {
          fields: _push(prevState.fields, field)
        });
      });
    }
  }, {
    key: 'pop',
    value: function pop() {
      this.setState(function (prevState) {
        return _extends({}, prevState, {
          fields: _pop(prevState.fields)
        });
      });
    }
  }, {
    key: 'unshift',
    value: function unshift() {
      this.setState(function (prevState) {
        return _extends({}, prevState, {
          fields: _unshift(prevState.fields)
        });
      });
    }
  }, {
    key: 'swap',
    value: function swap(indexA, indexB) {
      this.setState(function (prevState) {
        return _extends({}, prevState, {
          fields: _swap(prevState.fields, indexA, indexB)
        });
      });
    }
  }, {
    key: 'move',
    value: function move(from, to) {
      this.setState(function (prevState) {
        return _extends({}, prevState, {
          fields: _move(prevState.fields, from, to)
        });
      });
    }
  }, {
    key: 'insert',
    value: function insert(index, field) {
      this.setState(function (prevState) {
        return _extends({}, prevState, {
          fields: _insert(prevState.fields, index, field)
        });
      });
    }
  }, {
    key: 'replace',
    value: function replace(index, field) {
      this.setState(function (prevState) {
        return _extends({}, prevState, {
          fields: _replace(prevState.fields, index, field)
        });
      });
    }
  }, {
    key: 'remove',
    value: function remove(index) {
      this.setState(function (prevState) {
        return _extends({}, prevState, {
          fields: _remove(prevState.fields, index)
        });
      });
    }
  }, {
    key: 'getFieldProps',
    value: function getFieldProps(field, index) {
      var _props = this.props,
          name = _props.name,
          initialFields = _props.initialFields,
          render = _props.render,
          children = _props.children,
          rest = objectWithoutProperties(_props, ['name', 'initialFields', 'render', 'children']);


      return _extends({
        key: field.id,
        name: name + '.' + index
      }, rest, field);
    }
  }, {
    key: 'getFieldArrayProps',
    value: function getFieldArrayProps() {
      var fields = this.state.fields;


      return _extends({
        fields: fields
      }, this.fieldArrayState);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          render = _props2.render,
          children = _props2.children;


      var fieldArrayState = this.getFieldArrayProps();

      return isFunction(children) ? children(fieldArrayState) : isFunction(render) ? render(fieldArrayState) : null;
    }
  }]);
  return FieldArray;
}(React.Component), _class$3.defaultProps = {
  initialFields: []
}, _temp$2);

function withForm(_ref) {
  var _ref$name = _ref.name,
      name = _ref$name === undefined ? 'form' : _ref$name,
      _ref$mapPropsToValues = _ref.mapPropsToValues,
      mapPropsToValues = _ref$mapPropsToValues === undefined ? function () {
    return {};
  } : _ref$mapPropsToValues,
      rest = objectWithoutProperties(_ref, ['name', 'mapPropsToValues']);

  return function (WrappedComponent) {
    return function (props) {
      var reactFormsProps = _extends({}, rest, {
        initialValues: mapPropsToValues(props),
        outerProps: props
      });
      return React__default.createElement(
        AsyncValuesWrapper,
        reactFormsProps,
        function (reactForms) {
          var formProps = defineProperty({}, name, reactForms);
          return React__default.createElement(WrappedComponent, _extends({}, props, formProps));
        }
      );
    };
  };
}

exports.ReactForms = AsyncValuesWrapper;
exports.Form = Form;
exports.Field = Field;
exports.FieldArray = FieldArray;
exports.FormConsumer = FormConsumer;
exports.withForm = withForm;
exports.withContext = withContext;
//# sourceMappingURL=react-forms.cjs.development.js.map
